/*
 *	fram.c
 *
 *	ATARI VCS/EMU
 *
 *	* Tue Mar 15 20:31:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

// extern int CYCLE; /* RAMɔzu */
// extern int NOW;   /* RAMɔzu */
asm("
	.code				; RAMɔzu邽߁Aϐł.codeZNVƂ܂B
	.align	2
	.global	CYCLE
	.global	NOW
CYCLE:
	.word	0
NOW:
	.word	0
");

// int/*%data*/ vcs_read(/*%addr*/)
asm("
	.code
	.align	1
	.global	vcs_read
vcs_read:
	xcmp	%r0, 0x0080		; $0000-$007F: TIA
	xjrlt	_vcs_read_tia
	xcmp	%r0, 0x0280		; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	xjrlt	_vcs_read_mem
	xcmp	%r0, 0x0300		; $0280-$02FF: PIA
	xjrlt	_vcs_read_pia
	; /** FALLTHRU **/		; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_vcs_read_mem:
	ext	m6502mem@ah
	ext	m6502mem@al
	ld.ub	%r1, [%r0]
	ret
	;----------------------
_vcs_read_tia:
	xcall.d	m6502cpu_leave
	ld.w	%r12, %r0		; %r12 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r13, [NOW]		; %r13  = NOW
	sub	%r9, %r3		; %r9   =        CYCLE - m6502cpu.cycle
	add	%r13, %r9		; %r13  = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[NOW], %r13		; NOW   = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[CYCLE], %r3		; CYCLE =                m6502cpu.cycle
	;
	xcall	tia_read		; return tia_read(addr, NOW)
	xjp.d	m6502cpu_enter
	ld.w	%r1, %r10		; %r10 -> %data *delay*
	;----------------------
_vcs_read_pia:
	xcall.d	m6502cpu_leave
	ld.w	%r12, %r0		; %r12 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r13, [NOW]		; %r13  = NOW
	sub	%r9, %r3		; %r9   =        CYCLE - m6502cpu.cycle
	add	%r13, %r9		; %r13  = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[NOW], %r13		; NOW   = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[CYCLE], %r3		; CYCLE =                m6502cpu.cycle
	;
	xcall	pia_read		; return pia_read(addr, NOW)
	xjp.d	m6502cpu_enter
	ld.w	%r1, %r10		; %r10 -> %data *delay*
");

// void vcs_write(/*%addr,%data*/)
asm("
	.code
	.align	1
	.global	vcs_write
vcs_write:
	xcmp	%r0, 0x0080		; $0000-$007F: TIA
	xjrlt	_vcs_write_tia
	xcmp	%r0, 0x0280		; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	xjrlt	_vcs_write_mem
	xcmp	%r0, 0x0300		; $0280-$02FF: PIA
	xjrlt	_vcs_write_pia
	ret				; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_vcs_write_mem:
	ext	m6502mem@ah
	ext	m6502mem@al
	ld.b	[%r0], %r1
	ret
	;----------------------
_vcs_write_tia:
	xcall.d	m6502cpu_leave
	ld.w	%r12, %r0		; %r12 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r14, [NOW]		; %r14  = NOW
	sub	%r9, %r3		; %r9   =        CYCLE - m6502cpu.cycle
	add	%r14, %r9		; %r14  = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[NOW], %r14		; NOW   = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[CYCLE], %r3		; CYCLE =                m6502cpu.cycle
	;
	xcall.d	tia_write		; retval = tia_write(addr, data, NOW)
	ld.w	%r13, %r1		; %r13 <- %data
	xcmp	%r10, 0			; if(retval) { /* WSYNC̏ꍇ̂ */
	xjreq	m6502cpu_enter
	sub	%r3, %r10		;   m6502cpu.cycle -= retval
	xld.w	[m6502cpu+20], %r3	;   m6502cpu.cyclẽItZbg=20Ɉˑ!!
	xjp	m6502cpu_enter		; }
	;----------------------
_vcs_write_pia:
	xcall.d	m6502cpu_leave
	ld.w	%r12, %r0		; %r12 <- %addr *delay*
	;
	xld.w	%r9, [CYCLE]		; %r9   =        CYCLE
	xld.w	%r14, [NOW]		; %r14  = NOW
	sub	%r9, %r3		; %r9   =        CYCLE - m6502cpu.cycle
	add	%r14, %r9		; %r14  = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[NOW], %r14		; NOW   = NOW + (CYCLE - m6502cpu.cycle)
	xld.w	[CYCLE], %r3		; CYCLE =                m6502cpu.cycle
	;
	xcall.d	pia_write		; pia_write(addr, data, NOW)
	ld.w	%r13, %r1		; %r13 <- %data
	xjp	m6502cpu_enter
");

